SystemOrganization addCategory: #Metaprogramacion!

Error subclass: #TheMethodIsInvalid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

TestCase subclass: #TestMetaprogramacion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!TestMetaprogramacion methodsFor: 'methods generator' stamp: 'TomasRodriguez 6/24/2013 13:10'!
correctAbstractMethod01 

	^ ClassA compiledMethodAt: #correctAbstractMethod01! !

!TestMetaprogramacion methodsFor: 'methods generator' stamp: 'TomasRodriguez 6/24/2013 13:10'!
correctAbstractMethod02

	^ ClassA compiledMethodAt: #correctAbstractMethod02! !

!TestMetaprogramacion methodsFor: 'methods generator' stamp: 'TomasRodriguez 6/24/2013 13:15'!
missingAbstractMethod01
	
	^ ClassA compiledMethodAt: #missingAbstractMethod01
	! !

!TestMetaprogramacion methodsFor: 'subclasses set generator' stamp: 'TomasRodriguez 6/24/2013 17:29'!
missingAbstractMethodSubClassesSet
	
	| subClassesSet |
	subClassesSet := Set new.
	subClassesSet add: ClassE.
	subClassesSet add: ClassG.
	subClassesSet add: ClassH.
	
	^ subClassesSet 
	! !

!TestMetaprogramacion methodsFor: 'methods generator' stamp: 'TomasRodriguez 6/24/2013 13:04'!
notAbstractMethod
	
	^ ClassA compiledMethodAt: #notAbstractMethod! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'TomasRodriguez 6/24/2013 13:10'!
test01CreatingAMissinImplementorsShouldReturnASet

	| aCompiledMethod |
	aCompiledMethod := self correctAbstractMethod01 .
	self assert: ((MissingImplementors method: aCompiledMethod) class = Set )! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'FedericoMendez 6/24/2013 18:08'!
test02CanNotCreateAMissinImplementorsIfTheMethodIsNotAbstract

	| aCompiledMethod |
	aCompiledMethod := self notAbstractMethod.
	
	self
		should: [ MissingImplementors method: aCompiledMethod ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = MissingImplementors methodShouldBeAbstractErrorMessage ]! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'TomasRodriguez 6/24/2013 13:11'!
test03MissinImplementorsWithAMethodImplementedInAllSubClassesShouldReturnAndEmptySet

	| aCompiledMethod otherCompiledMethod |
	aCompiledMethod := self correctAbstractMethod01 .
	otherCompiledMethod := self correctAbstractMethod02 .
	self assert: (MissingImplementors method: aCompiledMethod) isEmpty .
	self assert: (MissingImplementors method: otherCompiledMethod) isEmpty .! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'TomasRodriguez 6/24/2013 17:30'!
test04MissinImplementorsWithAMethodNotImplementedInSubClassesShouldReturnASetWithTheSubClass

	| aCompiledMethod |
	aCompiledMethod := self missingAbstractMethod01 .
	self assert: (MissingImplementors method: aCompiledMethod) = self missingAbstractMethodSubClassesSet! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'TomasRodriguez 6/24/2013 17:32'!
test05ClassesInTheSetShouldBeSubClassesOfTheCompiledMethodClass

	| aCompiledMethod |
	aCompiledMethod := self missingAbstractMethod01 .

	(MissingImplementors method: aCompiledMethod) do: [ :aSubClass |
		aSubClass allSuperclasses includes: aCompiledMethod class.
		]! !

!TestMetaprogramacion methodsFor: 'MissinImplementors Test' stamp: 'FedericoMendez 6/24/2013 18:06'!
test06MissinImplementorsWithANonValidMethodShouldReturnTheMethodIsInvalidException

	| anInvalidMethod |
	anInvalidMethod := 'invalidMethod' .
	
	self should: [MissingImplementors method: anInvalidMethod] raise: TheMethodIsInvalid .! !

Object subclass: #ClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassA methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 14:47'!
correctAbstractMethod01

	self subclassResponsibility  ! !

!ClassA methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 14:47'!
correctAbstractMethod02

	self subclassResponsibility  ! !

!ClassA methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 14:48'!
missingAbstractMethod01

	self subclassResponsibility  ! !

!ClassA methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 14:48'!
notAbstractMethod ! !

ClassA subclass: #ClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassB methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 13:05'!
correctAbstractMethod01! !

ClassB subclass: #ClassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassD methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:33'!
correctAbstractMethod02! !

!ClassD methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:33'!
missingAbstractMethod01! !

ClassB subclass: #ClassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassE methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:34'!
correctAbstractMethod02! !

ClassB subclass: #ClassF
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassF methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:34'!
correctAbstractMethod02

! !

!ClassF methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:33'!
missingAbstractMethod01! !

ClassA subclass: #ClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassC methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 13:05'!
correctAbstractMethod01! !

!ClassC methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/24/2013 12:34'!
correctAbstractMethod02! !

ClassC subclass: #ClassG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassC subclass: #ClassH
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Object subclass: #MissingImplementors
	instanceVariableNames: 'missingSubClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MissingImplementors class methodsFor: 'assertions' stamp: 'TomasRodriguez 6/24/2013 12:54'!
assertIsAbstract: aCompiledMethod 

	( aCompiledMethod isAbstract ) ifFalse: [ self signalMethodShouldBeAbstract ]! !

!MissingImplementors class methodsFor: 'initialize' stamp: 'FedericoMendez 6/24/2013 18:08'!
method: aCompiledMethod 
	
	(aCompiledMethod isKindOf: CompiledMethod) ifFalse: [ ^ TheMethodIsInvalid signal ] .
	
	self assertIsAbstract: aCompiledMethod  .
	
	^ self new method: aCompiledMethod ! !

!MissingImplementors class methodsFor: 'error message' stamp: 'TomasRodriguez 6/24/2013 12:56'!
methodShouldBeAbstractErrorMessage

	^ 'The method should be Abstract'.! !

!MissingImplementors class methodsFor: 'error signal' stamp: 'TomasRodriguez 6/24/2013 12:55'!
signalMethodShouldBeAbstract 

	self error: self methodShouldBeAbstractErrorMessage! !

!MissingImplementors methodsFor: 'other methods' stamp: 'TomasRodriguez 6/24/2013 13:26'!
getChildrensOf: aClass

	^ aClass selectSubclasses: [ :aSubClass | aSubClass allSubclasses isEmpty ]! !

!MissingImplementors methodsFor: 'initialization' stamp: 'TomasRodriguez 6/24/2013 13:18'!
initialize 

	missingSubClasses := Set new.! !

!MissingImplementors methodsFor: 'initialization' stamp: 'FedericoMendez 6/24/2013 18:07'!
method: aCompiledMethod 
	
	| methodClassLeaves classWithSelector |
	methodClassLeaves := self getChildrensOf: aCompiledMethod methodClass .
	
	methodClassLeaves do: [ :aSubClass | 
		classWithSelector := aSubClass whichClassIncludesSelector: aCompiledMethod selector.
		(classWithSelector = aCompiledMethod class or: (classWithSelector compiledMethodAt: aCompiledMethod selector) isAbstract ) ifTrue: [ missingSubClasses add: aSubClass ]
		].
	
	^ missingSubClasses.! !
